#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/Axis.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/TypeMapping.h>

#include <axis/Axis.h>

STORAGE_CLASS_INFO void axiscInitializeAxis(AxiscBool bIsServer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscInitializeAxis", NULL, 1,
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&bIsServer));	  /* AUTOINSERTED TRACE */
	#endif

	Axis::initialize(0==bIsServer);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscInitializeAxis", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
} 
STORAGE_CLASS_INFO void axiscTerminate() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscTerminate", NULL, 0);	  /* AUTOINSERTED TRACE */
	#endif

	Axis::terminate();
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscTerminate", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

}

AXISC_STORAGE_CLASS_INFO void axiscAxisDelete(void * pValue,  AXISC_XSDTYPE type)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscAxisDelete", NULL, 2,
					TRACETYPE_POINTER, 1, ((void*)&pValue),
					TRACETYPE_DATA, sizeof(AXISC_XSDTYPE), ((void*)&type));	  /* AUTOINSERTED TRACE */
	#endif

    Axis::AxisDelete(pValue, (XSDTYPE) type);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscAxisDelete", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

