#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/IAttribute.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/IAttribute.h>

AXISC_STORAGE_CLASS_INFO void axiscDestroyIAttribute(AXISCHANDLE attribute) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyIAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute));	  /* AUTOINSERTED TRACE */
	#endif

	IAttribute *attr = (IAttribute*)attribute;
	delete attr;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyIAttribute", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO int axiscSetValueIAttribute(AXISCHANDLE attribute, const AxiscChar * value) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetValueIAttribute", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

	if(!value)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetValueIAttribute", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	IAttribute *attr = (IAttribute*)attribute;
	attr->setValue(value);
	
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetValueIAttribute", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetUriIAttribute(AXISCHANDLE attribute, const AxiscChar * uri) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetUriIAttribute", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&uri));	  /* AUTOINSERTED TRACE */
	#endif

	if(!uri)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetUriIAttribute", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	IAttribute *attr = (IAttribute*)attribute;
	attr->setURI(uri);
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetUriIAttribute", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetPrefixIAttribute(AXISCHANDLE attribute, const AxiscChar * prefix) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetPrefixIAttribute", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix));	  /* AUTOINSERTED TRACE */
	#endif

	if(!prefix)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetPrefixIAttribute", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	
	IAttribute *attr = (IAttribute*)attribute;
	attr->setPrefix(prefix);
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetPrefixIAttribute", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetLocalNameIAttribute(AXISCHANDLE attribute, const AxiscChar * localname) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetLocalNameIAttribute", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&localname));	  /* AUTOINSERTED TRACE */
	#endif

	if(!localname)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetLocalNameIAttribute", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	IAttribute *attr = (IAttribute*)attribute;
	attr->setLocalName(localname);
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetLocalNameIAttribute", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetValueIAttribute(AXISCHANDLE attribute) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetValueIAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute));	  /* AUTOINSERTED TRACE */
	#endif

	IAttribute *attr = (IAttribute*)attribute;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (attr->getValue());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetValueIAttribute", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return attr->getValue();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetUri(AXISCHANDLE attribute) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetUri", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute));	  /* AUTOINSERTED TRACE */
	#endif

	IAttribute *attr = (IAttribute*)attribute;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (attr->getURI());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetUri", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return attr->getURI();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetPrefixIAttribute(AXISCHANDLE attribute) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetPrefixIAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute));	  /* AUTOINSERTED TRACE */
	#endif

	IAttribute *attr = (IAttribute*)attribute;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (attr->getPrefix());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetPrefixIAttribute", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return attr->getPrefix();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetLocalNameIAttribute(AXISCHANDLE attribute) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLocalNameIAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&attribute));	  /* AUTOINSERTED TRACE */
	#endif

	IAttribute *attr = (IAttribute*)attribute;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (attr->getLocalName());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLocalNameIAttribute", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return attr->getLocalName();
		#endif
	}

}

}

