#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/AxisException.hpp>

#include <axis/ISoapFault.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/ISoapFault.h>

AXISC_STORAGE_CLASS_INFO void axiscDestroyISoapFault(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyISoapFault", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
	delete sf;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyISoapFault", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO const AxiscChar* axiscGetCmplxFaultObjectName(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCmplxFaultObjectName", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (sf->getCmplxFaultObjectName());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCmplxFaultObjectName", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getCmplxFaultObjectName();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxFaultObject(AXISCHANDLE soapFault, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCmplxFaultObject", NULL, 6,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_POINTER, 1, ((void*)&pDZFunct),
					TRACETYPE_POINTER, 1, ((void*)&pCreFunct),
					TRACETYPE_POINTER, 1, ((void*)&pDelFunct),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			void* traceRet = (sf->getCmplxFaultObject(pDZFunct,pCreFunct,pDelFunct,pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCmplxFaultObject", NULL, 0,
					TRACETYPE_POINTER, 1, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getCmplxFaultObject(pDZFunct,pCreFunct,pDelFunct,pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxisChar* axiscGetSimpleFaultDetail(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetSimpleFaultDetail", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (sf->getSimpleFaultDetail());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetSimpleFaultDetail", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getSimpleFaultDetail();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxisChar* axiscGetFaultcode(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFaultcode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (sf->getFaultcode());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFaultcode", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getFaultcode();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxisChar* axiscGetFaultstring(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFaultstring", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (sf->getFaultstring());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFaultstring", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getFaultstring();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxisChar* axiscGetFaultactor(AXISCHANDLE soapFault) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFaultactor", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (sf->getFaultactor());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFaultactor", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->getFaultactor();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetFaultcode(AXISCHANDLE soapFault, const AxisChar*  sFaultcode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetFaultcode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_STRING, 0, ((void*)&sFaultcode));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (sf->setFaultcode(sFaultcode));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetFaultcode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->setFaultcode(sFaultcode);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetFaultstring(AXISCHANDLE soapFault, const AxisChar*  sFaultstring) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetFaultstring", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_STRING, 0, ((void*)&sFaultstring));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (sf->setFaultstring(sFaultstring));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetFaultstring", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->setFaultstring(sFaultstring);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetFaultactor(AXISCHANDLE soapFault, const AxisChar*  sFaultactor) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetFaultactor", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_STRING, 0, ((void*)&sFaultactor));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (sf->setFaultactor(sFaultactor));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetFaultactor", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->setFaultactor(sFaultactor);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetFaultDetail(AXISCHANDLE soapFault, const AxisChar*  sFaultdetail) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetFaultDetail", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_STRING, 0, ((void*)&sFaultdetail));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (sf->setFaultDetail(sFaultdetail));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetFaultDetail", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->setFaultDetail(sFaultdetail);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetCmplxFaultObject(AXISCHANDLE soapFault, const void * pCmplxFaultObject) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetCmplxFaultObject", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&soapFault),
					TRACETYPE_POINTER, 1, ((void*)&pCmplxFaultObject));	  /* AUTOINSERTED TRACE */
	#endif

	ISoapFault *sf = (ISoapFault*)soapFault;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (sf->setCmplxFaultObject(pCmplxFaultObject));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetCmplxFaultObject", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return sf->setCmplxFaultObject(pCmplxFaultObject);
		#endif
	}

}

}

