#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/* -*- C++ -*- */

/*
 *   Copyright 2005 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 *
 *   @author John Kelly (john_kelly@uk.ibm.com)
 *
 */

#include "../platforms/PlatformAutoSense.hpp"

#include "axis/AxisCPPConfigDefaults.hpp"

#include "AxisCPPConfigDefaultsImpl.hpp"

#include "AxisUtils.h"

#include <stdlib.h>

#include <iostream>

#include <string.h>

AXIS_CPP_NAMESPACE_START 
AxisCPPConfigDefaults::AxisCPPConfigDefaults ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "AxisCPPConfigDefaults", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl = new AxisCPPConfigDefaultsImpl(); 
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "AxisCPPConfigDefaults", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AxisCPPConfigDefaults::~AxisCPPConfigDefaults ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "~AxisCPPConfigDefaults", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    delete m_pImpl;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "~AxisCPPConfigDefaults", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::apply ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "apply", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->apply();
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "apply", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setClientLog (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setClientLog", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setClientLog(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setClientLog", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setClientWSDDFile (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setClientWSDDFile", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setClientWSDDFile(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setClientWSDDFile", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setXMLParserLibrary (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setXMLParserLibrary", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setXMLParserLibrary(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setXMLParserLibrary", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setHTTPTransportLibrary (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setHTTPTransportLibrary", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setHTTPTransportLibrary(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setHTTPTransportLibrary", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setHTTPChannelLibrary (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setHTTPChannelLibrary", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setHTTPChannelLibrary(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setHTTPChannelLibrary", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setHTTPSSLChannelLibrary (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setHTTPSSLChannelLibrary", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setHTTPSSLChannelLibrary(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setHTTPSSLChannelLibrary", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setNodeName (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setNodeName", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setNodeName(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setNodeName", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setListenPort (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setListenPort", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setListenPort(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setListenPort", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setSecureInfo (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setSecureInfo", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setSecureInfo(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setSecureInfo", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void AxisCPPConfigDefaults::setAxisHome (char *value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "setAxisHome", this, 1,
					TRACETYPE_STRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

    m_pImpl->setAxisHome(value);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "setAxisHome", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

char* AxisCPPConfigDefaults::getClientLog ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getClientLog", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getClientLog());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getClientLog", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getClientLog();
		#endif
	}

}

char* AxisCPPConfigDefaults::getClientWSDDFile ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getClientWSDDFile", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getClientWSDDFile());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getClientWSDDFile", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getClientWSDDFile();
		#endif
	}

}

char* AxisCPPConfigDefaults::getXMLParserLibrary ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getXMLParserLibrary", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getXMLParserLibrary());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getXMLParserLibrary", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getXMLParserLibrary();
		#endif
	}

}

char* AxisCPPConfigDefaults::getHTTPTransportLibrary ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getHTTPTransportLibrary", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getHTTPTransportLibrary());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getHTTPTransportLibrary", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getHTTPTransportLibrary();
		#endif
	}

}

char* AxisCPPConfigDefaults::getHTTPChannelLibrary ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getHTTPChannelLibrary", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getHTTPChannelLibrary());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getHTTPChannelLibrary", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getHTTPChannelLibrary();
		#endif
	}

}

char* AxisCPPConfigDefaults::getHTTPSSLChannelLibrary ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getHTTPSSLChannelLibrary", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getHTTPSSLChannelLibrary());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getHTTPSSLChannelLibrary", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getHTTPSSLChannelLibrary();
		#endif
	}

}

char* AxisCPPConfigDefaults::getNodeName ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getNodeName", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getNodeName());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getNodeName", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getNodeName();
		#endif
	}

}

char* AxisCPPConfigDefaults::getListenPort ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getListenPort", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getListenPort());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getListenPort", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getListenPort();
		#endif
	}

}

char* AxisCPPConfigDefaults::getSecureInfo ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getSecureInfo", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getSecureInfo());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getSecureInfo", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getSecureInfo();
		#endif
	}

}

char* AxisCPPConfigDefaults::getAxisHome ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisCPPConfigDefaults", "getAxisHome", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char*)m_pImpl->getAxisHome());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisCPPConfigDefaults", "getAxisHome", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char*)m_pImpl->getAxisHome();
		#endif
	}

}

/** /todo place some sample code here
*/

AXIS_CPP_NAMESPACE_END

