#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

/*
 * @author Rangika Mendis (rangika@opensource.lk)
 * @author Nithyakala Thangarajah (nithya@opensource.lk)
 * @author Roshan Weerasuriya (roshan@opensource.lk, roshan@jkcsworld.com)
 *
 */

// SoapAttachmentHeaders.cpp: implementation of the SoapAttachmentHeaders class.

//

//////////////////////////////////////////////////////////////////////

#include "SoapAttachmentHeaders.hpp"

#include "SoapSerializer.h"

AXIS_CPP_NAMESPACE_START

//////////////////////////////////////////////////////////////////////

// Construction/Destruction

//////////////////////////////////////////////////////////////////////

SoapAttachmentHeaders::SoapAttachmentHeaders()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentHeaders", "SoapAttachmentHeaders", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "SoapAttachmentHeaders", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

SoapAttachmentHeaders::~SoapAttachmentHeaders()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentHeaders", "~SoapAttachmentHeaders", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "~SoapAttachmentHeaders", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void SoapAttachmentHeaders::addHeader(AxisString name, AxisString value)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentHeaders", "addHeader", this, 2,
					TRACETYPE_STLSTRING, 0, ((void*)&name),
					TRACETYPE_STLSTRING, 0, ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

	bool found = false;
	for (unsigned int i = 0; i < m_AttachHeaders.size (); i++)
	{
		if (m_AttachHeaders[i].first == name)
		{
			m_AttachHeaders[i] = make_pair(name, value);
			found = true;
			break;
		}
	}
	if (!found)
		m_AttachHeaders.push_back (make_pair (name, value));
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "addHeader", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void SoapAttachmentHeaders::serialize(SoapSerializer &pSZ)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentHeaders", "serialize", this, 1,
					TRACETYPE_DATA, sizeof(SoapSerializer&), ((void*)&pSZ));	  /* AUTOINSERTED TRACE */
	#endif

	for (unsigned int i = 0; i < m_AttachHeaders.size (); i++)
	{
	    if (m_AttachHeaders[i].first == AXIS_CONTENT_ID)
	    {
			pSZ.serialize((m_AttachHeaders[i].first).c_str(), ": <", NULL);
			pSZ.serialize((m_AttachHeaders[i].second).c_str(), ">\r\n", NULL);
		} else {
			pSZ.serialize((m_AttachHeaders[i].first).c_str(), ": ", NULL);
			pSZ.serialize((m_AttachHeaders[i].second).c_str(), "\r\n", NULL); 
		}
	}
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "serialize", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

const char *SoapAttachmentHeaders::getHeader(AxisString sName)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentHeaders", "getHeader", this, 1,
					TRACETYPE_STLSTRING, 0, ((void*)&sName));	  /* AUTOINSERTED TRACE */
	#endif

	for (unsigned int i = 0; i < m_AttachHeaders.size (); i++)
	{
		if (m_AttachHeaders[i].first == AXIS_CONTENT_ID)
		{
				{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (m_AttachHeaders[i].second.c_str());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "getHeader", this, 1,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_AttachHeaders[i].second.c_str();
		#endif
	}

		}
	}
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = ("");
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentHeaders", "getHeader", this, 2,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return "";
		#endif
	}

}

AXIS_CPP_NAMESPACE_END

