#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

/* SoapBinInputStream.cpp: implementation of the SoapBinInputStream class. */

#include "SoapBinInputStream.h"

SoapBinInputStream::SoapBinInputStream(AxisIOStream* pInputStream)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapBinInputStream", "SoapBinInputStream", this, 1,
					TRACETYPE_POINTER, sizeof(AxisIOStream), ((void*)&pInputStream));	  /* AUTOINSERTED TRACE */
	#endif

    m_pInputStream = pInputStream;
    m_nByteCount = 0;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapBinInputStream", "SoapBinInputStream", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

SoapBinInputStream::~SoapBinInputStream()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapBinInputStream", "~SoapBinInputStream", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapBinInputStream", "~SoapBinInputStream", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

/*
 * I dont really understand the use of this function
 */

unsigned int SoapBinInputStream::curPos() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapBinInputStream", "curPos", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			unsigned int traceRet = (m_nByteCount);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapBinInputStream", "curPos", this, 0,
					TRACETYPE_UINT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_nByteCount;
		#endif
	}

}

unsigned int SoapBinInputStream::readBytes(XMLByte* const pcToFill,
                                           const unsigned int iMaxToRead)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapBinInputStream", "readBytes", this, 2,
					TRACETYPE_POINTER, sizeof(XMLByte), ((void*)&pcToFill),
					TRACETYPE_UINT, 0, ((void*)&iMaxToRead));	  /* AUTOINSERTED TRACE */
	#endif

    int iRead = iMaxToRead;
	m_pInputStream->getBytes((char*)pcToFill, &iRead);
	m_nByteCount += iRead;
    	{
		#ifdef ENABLE_AXISTRACE
			unsigned int traceRet = (iRead);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapBinInputStream", "readBytes", this, 0,
					TRACETYPE_UINT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return iRead;
		#endif
	}

}

